%% Set Parameters for the full system in general form
%               dX = -f(X)dt + b(X) dW 
%  Aim to cover: gradient system, Langevin, Hamiltonian
%{
    Gradient system    dX = -gradV(X)dt + sigma dW; with 
% Xingjie's Entopy Barrier:  V(x,y) = fnA(x) + 
%      dx1 = - grad(fnA)(x1) dt + lambda*<x2-fnB(x1),grad(fnB(x1))> dt + sigma_1 dW_1(t)
%      dx2 = - lambda[x2- B(x1)]dt + sigma_2 dW_2(t)
%}

function [sysInfo,fmDataInfo] = model_settings_all_v2(SAVE_DIR,myslash)
 
scheme   = 'SSBE'; % 'Euler'; 
                    % 'SBE': stochatic Backward Euler
                    % 'SSBE': split-step stochastic Backward Euler

potential_type = 'Ax2Bsin';  %'x4';   % select potential type
      % 'Ax2Bsin'   'Ax4Bsin' : entropy Barrier
      % 'x4'                  : x^4; 
      % 'GradDiss'            : dissipative graduebt system
 
switch potential_type  
    case {'Ax2Bsin', 'Ax4Bsin'}
        [sysInfo,fmDataInfo]  = entropyBarrier(potential_type,scheme); 
    case {'x4'}
        [sysInfo,fmDataInfo]  = potential1D(potential_type,scheme);        
    case {'GradDiss'}
        [sysInfo,fmDataInfo]  = GradDiss_settings(potential_type,scheme);
end


%% set DIR for saving data
datapath           = [SAVE_DIR,potential_type, myslash,fmDataInfo.betaLambda,scheme, myslash];
if ~exist(datapath,'dir'), mkdir(datapath); end
datafileName       = [datapath,'Data_',fmDataInfo.type,'.mat'];
fmDataInfo.datapath     = datapath; 
fmDataInfo.datafileName = datafileName;  

end




