
function  hessGrad = Hess_grad(X,HessV,gradV,deltat)
% @(X) (eye(dimX)+ deltat*HessV(X))\ gradV(X);   
% ansatz from backward Euler

[dimX, tN] = size(X); Id = eye(dimX); 
hessGrad   = zeros(dimX,tN);
for t=1:tN
   X1            = X(:,t); 
   hessGrad(:,t) = (Id+ deltat*HessV(X1))\ gradV(X1);
end
end