
function [XnDiff,terms]  = IT1p5_trans2LSE(XnDiff,terms, MatHessV,useNoise)
% compute the likelihood of IT1.5 ansatz, transform to LSE form
%% output the terms afer an inverse step       >>>>>> may need some truncation to avoid singularity
Yn = terms{1}; t2 = terms{2}; t3 = terms{3}; 
tN = length(Yn(1,:));
switch useNoise
   case {0,10}  % multiplicative noise
         [XnDiff,Yn,t2,t3] = sqrt_covInverse_Vec3(tN,MatHessV,XnDiff,Yn,t2,t3);
         terms{1} = Yn;     terms{2} = t2;   terms{3} = t3;
    case 1      % multiplicative noise
        t4 = terms{4};
        [XnDiff, Yn,t2,t3,t4] = sqrt_covInverse_Vec4(tN,MatHessV,XnDiff,Yn,t2,t3,t4); 
        terms{1} = Yn;    terms{2} = t2;   terms{3} = t3;  terms{4} = t4;
%   case 11     % additive noise  -- no need the matrix inverse
 %       t4 = terms{4};
%        terms{1} = Yn;    terms{2} = t2;   terms{3} = t3;  terms{4} = t4;
end
end



function [XnDiff,Yn,t2,t3] = sqrt_covInverse_Vec3(tN,MatHessV,XnDiff,Yn,t2,t3)
% comopute sqrt(cov)\Vec
for t=1:tN
    MatH = MatHessV(:,:,t);
    XnDiff(:,t) = MatH\XnDiff(:,t); 
    temp = Yn(:,t);  Yn(:,t) = MatH\temp; temp = t2(:,t);  t2(:,t) = MatH\temp;
    temp = t3(:,t);  t3(:,t) = MatH\temp;
end
end


function [XnDiff,Yn,t2,t3,t4] = sqrt_covInverse_Vec4(tN,MatHessV,XnDiff,Yn,t2,t3,t4)
% comopute sqrt(cov)\Vec
for t=1:tN
    MatH = MatHessV(:,:,t);
    XnDiff(:,t) = MatH\XnDiff(:,t); 
    temp = Yn(:,t);  Yn(:,t) = MatH\temp; temp = t2(:,t);  t2(:,t) = MatH\temp;
    temp = t3(:,t);  t3(:,t) = MatH\temp; temp = t4(:,t);  t4(:,t) = MatH\temp;    
end
end