%% inferScheme -- infer a numerical scheme with a larger time step size
%   + as fast as an explicit scheme, an also get invariant measure as Implicit scheme
%{
Algorithm: 
   + generate data from an Implicit scheme (or another that accurately approximates the invariant measure)
   + estimate the parameters; 
   + run the infered scheme 
% Last updated 2021/1/16;  started 2020/12/23 
%} 

%% change the settign and run this code 
settings_inferScheme; 

rm_string          = rmInfo.nameStrFn(rmInfo.obsgap); 
estimator_filename = [rmInfo.rm_path, 'Estimator',rm_string,'.mat'];
if rmInfo.lse_entrywise == 1
    estimator_filename = [rmInfo.rm_path, 'Estimator',rm_string,'_LSEentrywise.mat'];
end
rmInfo.estimator_filename = estimator_filename;

%% downsample data and estimate the parameters
[X, dWDeltat] = DownSample_Data(data_fm,rmInfo); % downsample data ; dWDeltat ~ sqrt(deltat)*Bn 

if ~isfield(rmInfo,'termYnOFF'); rmInfo.termYnOFF = 0; end 


[cvec,res,LSE_Abres] = estimatePara_MLE(X, dWDeltat,rmInfo,sysInfo); 

cvec = real(cvec); 
deltat = rmInfo.deltat; 
fprintf('Estimated para (should be [0,1] when Euler) with deltat=%2.4f:\n',deltat); disp(cvec'); 
fprintf('sqrt(residual)*deltat %2.4f (vs Euler sqrt(deltat*2/beta)= %2.4f) \n',sqrt(res)*deltat,sqrt(deltat*2/sysInfo.beta)); 
save(estimator_filename, 'rmInfo', 'sysInfo','fmDataInfo','cvec','res','LSE_Abres');

%% run the inferred system
gapInd = 4; 
compare_1traj(X,dWDeltat,cvec,res,rmInfo,sysInfo,fmDataInfo,gapInd); 

coef_conv_deltat(gapseq,data_fm,rmInfo,fmDataInfo,sysInfo);     % test the convergence of the estimators  


