
function plot_TVD_relErr(scheme_cmp,fmDataInfo,gapStartInd,TV_RMvsTrue_array,TV_RM0vsTrue_array,rmInfo,gapseq,rel_err,rel_err_Euler)
%% Plot the total variation distances verse deltat=obsgap*dt for each scheme
scheme = scheme_cmp; 
IS_scheme = sprintf('IS-%s',rmInfo.rm_type); 
lgnd   = {IS_scheme,scheme}; 
figure; hold on;
dt    = fmDataInfo.dt;
Lgapseq = length(gapseq);  Indexes = gapStartInd:Lgapseq; 
plot(gapseq(Indexes)*dt,TV_RMvsTrue_array,'b-v','linewidth',2);
plot(gapseq(Indexes)*dt,TV_RM0vsTrue_array,'r-o','linewidth',2);
xlabel('\delta');ylabel('Total variation distance');legend(lgnd);
figpath     = rmInfo.fig_path; 
gapStr      = rmInfo.nameStrFn(rmInfo.obsgap); 
% figDataFile = [rmInfo.rm_path,'figData_',gapStr,'.mat'];
figname     = [figpath,'figTVD_',gapStr,'.pdf']; 
if rmInfo.lse_entrywise ==1
    % figDataFile = [rmInfo.rm_path,'figData_',gapStr,'_lseEntrywise.mat'];
    figname     = [figpath,'figTVD_',gapStr,'_lseEntrywise.pdf']; 
end
set_positionFonts;tightfig;
print(figname,'-dpdf');

%%------------------

figure;  % plot the relative error in E[X1^2];   NOT good. May be Total variation between invariant measure? 
plot(gapseq(Indexes),rel_err(Indexes),'-x'); hold on
plot(gapseq(Indexes),rel_err_Euler(Indexes),'-.*'); hold on; 
legend(IS_scheme,'Euler');
xlabel('Gap'); ylabel('Relative error E(x1^2)');
set_positionFonts; % set(gcf,'Position',  [100, 1000, 1200, 400]);
tightfig;
figname     = [rmInfo.fig_path,'fig_relErr_',gapStr,'.pdf']; 
if rmInfo.lse_entrywise ==1
    % figDataFile = [rmInfo.rm_path,'figData_',gapStr,'_lseEntrywise.mat'];
    figname     = [figpath,'fig_relErr_',gapStr,'_lseEntrywise.pdf']; 
end

print(figname,'-dpdf');
end 
