function data_fm = generateData(sysInfo,fmDataInfo,plotON,saveON,X_init)
% generate data for inference of reduced model 

if ~exist('saveON','var'); saveON =1; end
if ~exist('plotON','var'); plotON =0; end

if saveON == 1    % in 1traj-demo simulation, we save the traj; otherwise, no need to save the state trajectories in all M simulations; 
    datafileName = fmDataInfo.datafileName;
    if ~exist(datafileName,'file')
        fprintf(' Generating data from %s potential by %s \n', sysInfo.potential_type,fmDataInfo.scheme);
        switch fmDataInfo.scheme
            case 'Euler'
                [data_fm, ~,~] = forwardEuler(sysInfo,fmDataInfo);    % Data of the full system.
            case 'SBE'
                [data_fm,~]  = NoSplitBackwardEuler_v2(sysInfo,fmDataInfo);
            case 'SSBE'
                % [data_fm,~]  = backwardEuler(sysInfo,fmDataInfo);
                [data_fm,~]  = SplitStepBackwardEuler_v2(sysInfo,fmDataInfo);
        end
        save(datafileName, 'data_fm','sysInfo','fmDataInfo'); % the size of full system is about 300MB
    end
    load(datafileName,'data_fm');
   
    if plotON == 1; plot_full_system; end     % plot the potential and solution
else   % for Mtraj, we do not save data_fm
    switch fmDataInfo.scheme
        case 'Euler'
            [data_fm, ~,~] = forwardEuler(sysInfo,fmDataInfo,X_init);    % Data of the full system.
        case 'SBE'
            [data_fm,~]    = NoSplitBackwardEuler_v2(sysInfo,fmDataInfo,X_init);
        case 'SSBE'
            % [data_fm,~]  = backwardEuler(sysInfo,fmDataInfo);
            [data_fm,~]  = SplitStepBackwardEuler_v2(sysInfo,fmDataInfo,X_init);
    end   
end



%{    
data_orig = struct( ...
    'X',        X,...
    'dWdt',     dWdt, ...
    'tN',       tN, ...
    'dt',       dt, ...
    'x_range',  [min(X(1,:)), max(X(1,:))], ...
    'y_range',  [min(X(2,:)), max(X(2,:))] ...
);
%}

