function data_fm = generateData1traj(sysInfo,fmDataInfo,rmInfo, plotON)
% generate data for inference of reduced model 
% - Only output the data for the reduced model

datafileName = fmDataInfo.datafileName; 
if ~exist(datafileName,'file')
        fprintf(' Generating data from %s potential: \n', sysInfo.potential_type )
        data_fm     = schemeEuler(sysInfo,fmDataInfo);           % Data of the full system.
        save(datafileName, 'data_fm','sysInfo','fmDataInfo'); % the size of full system is about 300MB
end    
load(datafileName,'data_fm');
    
if ~exist('plotON','var'); plotON =0; end
if plotON == 1; plot_full_system; end

% end 

%{    
The follow is previous code on processing data; particularly, discretize the noise process.     
    
    %% save data for RM inference
    data   = resolved_data1(data_fm,Potential_Parameter,1);   % data for inference of RM
    clear data_orig plotON; 
    save(data4RM,'data','Potential_Parameter','Sim_Parameter');

load(data4RM);  
%}
%% output data structure
%{
 data = struct( ...         
     'Xr',       Xr,...        
     'PdWdt',    PdWdt, ...
     'Xr_span',  Xr_span, ...
     'tN',       L+1, ...  
     'dx',       dx, ...
     'dt_obs',   dt_obs, ...
     'obsgap',   obsgap, ...
     'min_Xr',   min_Xr,...
     'max_Xr',   max_Xr...
 );
%}

